"""
Use a fact to turn toward an object when the goal is set.
"""

from planBaseClass import PlanBaseClass

class PlanClass (PlanBaseClass):
    NUMBER_GOALS = 1
    goalTurnTowardObject = 0

    NUMBER_MODULES = 3
    moduleTurnTowardObject = 0
    moduleTurnRight = 1
    moduleTurnLeft = 2

    NUMBER_FACTS = 2
    objectOnRightFact = 0
    objectOnLeftFact = 1

    NUMBER_ACTIONS = 4
    actionRight = 0
    actionLeft = 1
    actionForward = 2
    actionBackward = 3

    def __init__(self, simName,sim,neal,spinnVersion,fsa):
        PlanBaseClass.__init__(self,simName,sim,neal,spinnVersion,fsa)
        self.simName = simName
        self.sim = sim
        self.neal = neal
        self.spinnVersion = spinnVersion
        self.fsa = fsa
        self.initializeBasePlanner()

    def connectTurnTowardObjectPlanner(self):
        #turn toward object goal/module and right -> moduleRight
        self.goalStartsModule(self.goalTurnTowardObject,
                              self.moduleTurnTowardObject)
        self.moduleAndFactStartModuleWithAction(self.moduleTurnTowardObject,
            self.objectOnRightFact,self.moduleTurnRight,self.actionRight)
        self.moduleStopsModule(self.moduleTurnRight,self.moduleTurnTowardObject)
        self.actionStopsModule(self.actionRight,self.moduleTurnRight)
        self.actionStopsGoal(self.actionRight,self.goalTurnTowardObject)

        #turn toward object goal/module and fact left -> moduleLeft
        self.moduleAndFactStartModuleWithAction(self.moduleTurnTowardObject,
            self.objectOnLeftFact,self.moduleTurnLeft,self.actionLeft)
        self.moduleStopsModule(self.moduleTurnLeft,self.moduleTurnTowardObject)
        self.actionStopsModule(self.actionLeft,self.moduleTurnLeft)
        self.actionStopsGoal(self.actionLeft,self.goalTurnTowardObject)

        self.actionCausesReset(self.actionRight,self.resetCells)
        self.resetStopsFact(self.objectOnRightFact)
        self.actionCausesReset(self.actionLeft,self.resetCells)
        self.resetStopsFact(self.objectOnLeftFact)

    def printResults(self):
        PlanBaseClass.printResults(self)

