"""
This starts the goal, does the default move forward,
does the turn to object
does the move do object on fact
then ids the object and stops  
"""

from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
import pyNN.nest as sim

from iDObjPlanClass import PlanClass

#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY, min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def createInputs():
    inputSpikeTimes0 = [10.0]
    inputSpikeTimes1 = [500.0]
    inputSpikeTimes2 = [800.0]
    inputSpikeTimes3 = [1050.0]
    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')
    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
                                   label='inputSpikes_1')
    spikeGen2=sim.Population(1, sim.SpikeSourceArray, spikeArray2,
                                   label='inputSpikes_2')
    spikeGen3=sim.Population(1, sim.SpikeSourceArray, spikeArray3,
                                   label='inputSpikes_3')

    return [spikeGen0,spikeGen1,spikeGen2,spikeGen3]

#---main 
simName = "nest"
spinnVersion = -1

neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
planner = PlanClass(simName,sim,neal,spinnVersion,fsa)
planner.connectIDObjectPlanner()

spikeGenerators = createInputs()

planner.testSetGoal(planner.goalIDObject,spikeGenerators[0])

#no id, forward, left/right, so move forward

#no id or forward so turn left
planner.testTurnOnFact(planner.objectOnLeftFact,spikeGenerators[1])
#planner.testTurnOnFact(planner.objectOnRightFact,spikeGenerators[1])

#no id so move forward
planner.testTurnOnFact(planner.objectInFrontFact,spikeGenerators[2])


#id so stop
planner.testTurnOnFact(planner.objectIsDogFact,spikeGenerators[3])
#planner.testTurnOnFact(planner.objectIsCatFact,spikeGenerators[3])

neal.nealApplyProjections()
RUN_DURATION = 1500
sim.run(RUN_DURATION)

planner.printResults()
