
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
import pyNN.spiNNaker as sim

from modAndFactPlanClass import PlanClass

RUN_DURATION = 400
#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY, min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def createInputs():
    inputSpikeTimes0 = [10.0]
    inputSpikeTimes1 = [110.0]
    inputSpikeTimes2 = [210.0]
    inputSpikeTimes3 = [310.0]
    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')
    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
                                   label='inputSpikes_1')
    spikeGen2=sim.Population(1, sim.SpikeSourceArray, spikeArray2,
                                   label='inputSpikes_2')
    spikeGen3=sim.Population(1, sim.SpikeSourceArray, spikeArray3,
                                   label='inputSpikes_3')

    return [spikeGen0,spikeGen1,spikeGen2,spikeGen3]

#---main 
simName = "spinnaker"
spinnVersion = 8

neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
planner = PlanClass(simName,sim,neal,spinnVersion,fsa)
planner.connectTurnTowardObjectPlanner()

spikeGenerators = createInputs()

planner.testSetGoal(planner.goalTurnTowardObject,spikeGenerators[0])
planner.testTurnOnFact(planner.objectOnLeftFact,spikeGenerators[1])

planner.testTurnOnFact(planner.objectOnRightFact,spikeGenerators[2])
planner.testSetGoal(planner.goalTurnTowardObject,spikeGenerators[3])

neal.nealApplyProjections()
sim.run(RUN_DURATION)

planner.printResults()
