
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
import pyNN.spiNNaker as sim

from simpPlanClass import PlanClass

RUN_DURATION = 400
#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY, min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def createInputs():
    inputSpikeTimes0 = [10.0]
    inputSpikeTimes1 = [110.0]
    inputSpikeTimes2 = [210.0]
    inputSpikeTimes3 = [310.0]
    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')
    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
                                   label='inputSpikes_1')
    spikeGen2=sim.Population(1, sim.SpikeSourceArray, spikeArray2,
                                   label='inputSpikes_2')
    spikeGen3=sim.Population(1, sim.SpikeSourceArray, spikeArray3,
                                   label='inputSpikes_3')

    return [spikeGen0,spikeGen1,spikeGen2,spikeGen3]

    

#---main 
simName = "spinnaker"
spinnVersion = 8

neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
planner = PlanClass(simName,sim,neal,spinnVersion,fsa)
planner.connectSimplePlanner()

spikeGenerators = createInputs()
firstSpikeGenerator =  spikeGenerators[0]
secondSpikeGenerator =  spikeGenerators[1]
thirdSpikeGenerator =  spikeGenerators[2]
fourthSpikeGenerator =  spikeGenerators[3]

planner.testSetGoal(planner.goalTurnRight,firstSpikeGenerator)
planner.testSetGoal(planner.goalTurnLeft,secondSpikeGenerator)
planner.testSetGoal(planner.goalStepForward,thirdSpikeGenerator)
planner.testSetGoal(planner.goalStepBackward,fourthSpikeGenerator)

neal.nealApplyProjections()
sim.run(RUN_DURATION)

planner.printResults()
